/*
 * Yaver10View.java
 */

package yaver10;

import com.lti.civil.CaptureException;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import others.CaptureFrame;
import others.TestMotionDetection;

/**
 * The application's main frame.
 */
public class Yaver10View extends FrameView {

    public static int movementMode=0; // 0: Stationary  1:Walking  2:Running
    public static int lightMode=2;    // 0: Dark  1: Little bright 2: Normal 3: Bright 4: Too bright

    public Yaver10View(SingleFrameApplication app) throws IOException, InstantiationException, IllegalAccessException, CaptureException {
        super(app);

        initComponents();
        jLabel5.setVisible(false);
        jLabel6.setVisible(false);
        jLabel7.setVisible(false);
        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });

  //      mainPanel.
   //     mainPanel.setBounds(0, 0, screenSize.width, screenSize.height);
  //      jPanel1.setPreferredSize(new Dimension(100,100));
 //       SetTabbedPane();
       ReMap();
        String[] args= new String[1];
        args[0]="vfw://0";
        TestMotionDetection.main(args);
        //jEditorPane1.add(new CaptureFrame(DefaultCaptureSystemFactorySingleton.instance()).run());
    }

    public static void changeWRTLight()
    {
        switch(lightMode)
        {
            case 0:
                mainPanel.setBackground(Color.white);
                jLabel3.setForeground(Color.black);
                jLabel4.setForeground(Color.black);
                jLabel6.setForeground(Color.black);
                jLabel7.setForeground(Color.black);
                break;
            case 1:
                mainPanel.setBackground(Color.lightGray);
                jLabel3.setForeground(Color.black);
                jLabel4.setForeground(Color.black);
                jLabel6.setForeground(Color.black);
                jLabel7.setForeground(Color.black);
                break;
            case 2:
                mainPanel.setBackground(Color.gray);
                jLabel3.setForeground(Color.white);
                jLabel4.setForeground(Color.white);
                jLabel6.setForeground(Color.white);
                jLabel7.setForeground(Color.white);
                break;
            case 3:
                mainPanel.setBackground(Color.darkGray);
                jLabel3.setForeground(Color.white);
                jLabel4.setForeground(Color.white);
                jLabel6.setForeground(Color.white);
                jLabel7.setForeground(Color.white);
                break;
            case 4:
                mainPanel.setBackground(Color.black);
                jLabel3.setForeground(Color.white);
                jLabel4.setForeground(Color.white);
                jLabel6.setForeground(Color.white);
                jLabel7.setForeground(Color.white);
                break;

        }
    }

    public static void CheckEntities() throws IOException
    {
        int tempMode = yaver10.Yaver10View.movementMode;

        jSlider1.setVisible(others.Filtering.entities[0][tempMode]);
        button3.setVisible(others.Filtering.entities[1][tempMode]);
        button4.setVisible(others.Filtering.entities[1][tempMode]);
        button5.setVisible(others.Filtering.entities[1][tempMode]);
        button6.setVisible(others.Filtering.entities[1][tempMode]);
        jButton1.setVisible(others.Filtering.entities[3][tempMode]);
        jTextField1.setVisible(others.Filtering.entities[2][tempMode]);
        jTextField2.setVisible(others.Filtering.entities[2][tempMode]);
        jLabel3.setVisible(others.Filtering.entities[2][tempMode]);
        jLabel4.setVisible(others.Filtering.entities[2][tempMode]);
        jButton2.setVisible(others.Filtering.entities[4][tempMode]);
        jButton3.setVisible(others.Filtering.entities[5][tempMode]);
        jButton4.setVisible(others.Filtering.entities[6][tempMode]);
        jComboBox1.setVisible(others.Filtering.entities[7][tempMode]);
        switch(tempMode)
        {
            case 0:
                jSlider1.setSize(35, 200);
                button3.setSize(48, 10);
                button4.setSize(48, 10);
                button5.setSize(48, 10);
                button6.setSize(48, 10);
                jButton1.setSize(45, 23);
                jButton1.setFont(new Font("Tahoma",Font.PLAIN,11));
                jTextField1.setSize(6, 20);
                jTextField2.setSize(6, 20);
                jLabel3.setSize(39, 14);
                jLabel3.setFont(new Font("Tahoma",Font.PLAIN,11));
                jLabel4.setSize(39, 14);
                jLabel4.setFont(new Font("Tahoma",Font.PLAIN,11));
                jButton2.setSize(87, 23);
                jButton2.setFont(new Font("Tahoma",Font.PLAIN,11));
                jButton3.setSize(87, 23);
                jButton3.setFont(new Font("Tahoma",Font.PLAIN,11));
                jButton4.setSize(87, 23);
                jButton4.setFont(new Font("Tahoma",Font.PLAIN,11));
                jComboBox1.setSize(63, 20);
                zoomFactor=14;
                ReMap();
                break;
            case 1:
                jSlider1.setSize(45, 220);
                button3.setSize(50, 12);
                button4.setSize(50, 12);
                button5.setSize(50, 12);
                button6.setSize(50, 12);
                jButton1.setSize(55, 30);
                jButton1.setFont(new Font("Tahoma",Font.PLAIN,13));
                jTextField1.setSize(8, 25);
                jTextField2.setSize(8, 25);
                jLabel3.setSize(39, 14);
                jLabel3.setFont(new Font("Tahoma",Font.PLAIN,13));
                jLabel4.setSize(39, 14);
                jLabel4.setFont(new Font("Tahoma",Font.PLAIN,13));
                jButton2.setSize(98, 35);
                jButton2.setFont(new Font("Tahoma",Font.PLAIN,13));
                jButton3.setSize(98, 35);
                jButton3.setFont(new Font("Tahoma",Font.PLAIN,13));
                jButton4.setSize(98, 35);
                jButton4.setFont(new Font("Tahoma",Font.PLAIN,13));
                jComboBox1.setSize(75, 35);
                zoomFactor=17;
                ReMap();
                break;
            case 2:
                jSlider1.setSize(55, 240);
                button3.setSize(60, 15);
                button4.setSize(60, 15);
                button5.setSize(60, 15);
                button6.setSize(60, 15);
                jButton1.setSize(65, 40);
                jButton1.setFont(new Font("Tahoma",Font.PLAIN,16));
                jTextField1.setSize(6, 20);
                jTextField2.setSize(6, 20);
                jLabel3.setSize(39, 14);
                jLabel3.setFont(new Font("Tahoma",Font.PLAIN,16));
                jLabel4.setSize(39, 14);
                jLabel4.setFont(new Font("Tahoma",Font.PLAIN,16));
                int width=jButton2.getWidth();
                int height=jButton2.getHeight();
           //     jButton2.setLocation(300, 300);
                jButton2.setSize(100, 60);
                jButton2.setFont(new Font("Tahoma",Font.PLAIN,16));
                jButton3.setSize(100, 60);
                jButton3.setFont(new Font("Tahoma",Font.PLAIN,16));
                jButton4.setSize(100, 60);
                jButton4.setFont(new Font("Tahoma",Font.PLAIN,16));
                jComboBox1.setSize(90, 45);
                zoomFactor=20;
                ReMap();
                break;
        }
    }

    public static String UpdateMap(int size,double latitude,double longtitude,Integer zoom,String type)
    {
        String mapString="center="+Double.toString(latitude)+","+Double.toString(longtitude)+
                "&zoom="+Integer.toString(zoom)+
                "&size="+Integer.toString(size)+
                "x"+Integer.toString(size)+
                "&maptype="+type+markers+"&sensor=false";
        System.out.println(mapString);
        return mapString;
    }

    public static void ReMap() throws IOException
    {
      jTextPane1.setVisible(false);
      jTextPane1.removeAll();
      String lattem=String.valueOf(latitude);
      String longtem=String.valueOf(longtitude);
      if(lattem.length()>7)
      jTextField1.setText((String.valueOf(latitude)).substring(0, 7));
      else
      jTextField1.setText((String.valueOf(latitude)));
      if(longtem.length()>7)
      jTextField2.setText((String.valueOf(longtitude)).substring(0, 7));
      else
      jTextField2.setText((String.valueOf(longtitude)));
      String temp=UpdateMap(600,latitude,longtitude,zoomFactor,MapMode);
   //   jTextPane1.setSize(512, 512);
      jTextPane1.add(new others.GoogleMap(
    		  temp
      ));
      jTextPane1.setVisible(true);
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = Yaver10App.getApplication().getMainFrame();
            aboutBox = new Yaver10AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        Yaver10App.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        button3 = new java.awt.Button();
        button4 = new java.awt.Button();
        button5 = new java.awt.Button();
        button6 = new java.awt.Button();
        jSlider1 = new javax.swing.JSlider();
        jComboBox1 = new javax.swing.JComboBox();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        label1 = new java.awt.Label();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        mainPanel.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        mainPanel.setMaximumSize(new java.awt.Dimension(779, 700));
        mainPanel.setMinimumSize(new java.awt.Dimension(779, 700));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(779, 700));
        mainPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                mainPanelMouseEntered(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mainPanelMousePressed(evt);
            }
        });
        mainPanel.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                mainPanelFocusGained(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTextPane1.setMaximumSize(new java.awt.Dimension(1200, 1200));
        jTextPane1.setMinimumSize(new java.awt.Dimension(600, 600));
        jTextPane1.setName("jTextPane1"); // NOI18N
        jTextPane1.setPreferredSize(new java.awt.Dimension(600, 600));
        jTextPane1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextPane1MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTextPane1MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTextPane1MouseReleased(evt);
            }
        });
        jTextPane1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jTextPane1MouseDragged(evt);
            }
        });
        jScrollPane1.setViewportView(jTextPane1);

        button3.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(yaver10.Yaver10App.class).getContext().getResourceMap(Yaver10View.class);
        button3.setFont(resourceMap.getFont("Up.font")); // NOI18N
        button3.setLabel(resourceMap.getString("Up.label")); // NOI18N
        button3.setName("Up"); // NOI18N
        button3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button3ActionPerformed(evt);
            }
        });

        button4.setFont(resourceMap.getFont("Down.font")); // NOI18N
        button4.setLabel(resourceMap.getString("Down.label")); // NOI18N
        button4.setName("Down"); // NOI18N
        button4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button4ActionPerformed(evt);
            }
        });

        button5.setFont(resourceMap.getFont("Right.font")); // NOI18N
        button5.setLabel(resourceMap.getString("Right.label")); // NOI18N
        button5.setName("Right"); // NOI18N
        button5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button5ActionPerformed(evt);
            }
        });

        button6.setFont(resourceMap.getFont("Left.font")); // NOI18N
        button6.setLabel(resourceMap.getString("Left.label")); // NOI18N
        button6.setName("Left"); // NOI18N
        button6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button6ActionPerformed(evt);
            }
        });

        jSlider1.setMaximum(20);
        jSlider1.setMinimum(10);
        jSlider1.setOrientation(javax.swing.JSlider.VERTICAL);
        jSlider1.setPaintTicks(true);
        jSlider1.setValue(14);
        jSlider1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jSlider1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jSlider1.setName("jSlider1"); // NOI18N
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Hybrid", "Satellite", "Roads" }));
        jComboBox1.setMinimumSize(new java.awt.Dimension(0, 0));
        jComboBox1.setName("jComboBox1"); // NOI18N
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jTextField1.setMaximumSize(new java.awt.Dimension(6, 20));
        jTextField1.setName(""); // NOI18N
        jTextField1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextField1MouseClicked(evt);
            }
        });
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField1FocusGained(evt);
            }
        });

        jTextField2.setMaximumSize(new java.awt.Dimension(6, 20));
        jTextField2.setName(""); // NOI18N
        jTextField2.setRequestFocusEnabled(false);
        jTextField2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextField2MouseClicked(evt);
            }
        });
        jTextField2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField2FocusGained(evt);
            }
        });

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setMaximumSize(new java.awt.Dimension(500, 500));
        jButton1.setMinimumSize(new java.awt.Dimension(0, 0));
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        label1.setName("N"); // NOI18N
        label1.setVisible(false);

        jButton2.setFont(jButton2.getFont());
        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setMaximumSize(new java.awt.Dimension(500, 500));
        jButton2.setMinimumSize(new java.awt.Dimension(0, 0));
        jButton2.setName("jButton2"); // NOI18N
        jButton2.setPreferredSize(new java.awt.Dimension(87, 30));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText(resourceMap.getString("jButton3.text")); // NOI18N
        jButton3.setMaximumSize(new java.awt.Dimension(120, 50));
        jButton3.setMinimumSize(new java.awt.Dimension(80, 25));
        jButton3.setName("jButton3"); // NOI18N
        jButton3.setPreferredSize(new java.awt.Dimension(87, 25));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText(resourceMap.getString("jButton4.text")); // NOI18N
        jButton4.setMaximumSize(new java.awt.Dimension(87, 23));
        jButton4.setMinimumSize(new java.awt.Dimension(87, 23));
        jButton4.setName("jButton4"); // NOI18N
        jButton4.setPreferredSize(new java.awt.Dimension(87, 23));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setName("jLabel2"); // NOI18N

        jLabel3.setForeground(resourceMap.getColor("jLabel3.foreground")); // NOI18N
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setForeground(resourceMap.getColor("jLabel4.foreground")); // NOI18N
        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        jLabel5.setFont(resourceMap.getFont("jLabel5.font")); // NOI18N
        jLabel5.setForeground(resourceMap.getColor("jLabel5.foreground")); // NOI18N
        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jLabel6.setFont(resourceMap.getFont("jLabel6.font")); // NOI18N
        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        jLabel7.setFont(resourceMap.getFont("jLabel7.font")); // NOI18N
        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 602, Short.MAX_VALUE)
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
                                .addGap(148, 148, 148)
                                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 128, Short.MAX_VALUE)
                                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 124, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(77, 77, 77)
                                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(mainPanelLayout.createSequentialGroup()
                                        .addGap(84, 84, 84)
                                        .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(mainPanelLayout.createSequentialGroup()
                                        .addGap(81, 81, 81)
                                        .addComponent(jLabel1)
                                        .addGap(36, 36, 36)
                                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(42, 42, 42)
                                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(button4, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(jButton1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jTextField2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 74, Short.MAX_VALUE))))
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(42, 42, 42)
                                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jComboBox1, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jSlider1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(button3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE)))
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(22, 22, 22)
                                .addComponent(button6, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(button5, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 446, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 138, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(jLabel7)))
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGap(33, 33, 33)
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel1)
                                .addGap(157, 157, 157)
                                .addComponent(jLabel2))
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(2, 2, 2)
                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(33, 33, 33)
                                .addComponent(jSlider1, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(26, 26, 26)
                        .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(9, 9, 9)
                        .addComponent(button3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(button5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(button6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(button4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(31, 31, 31)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(11, 11, 11)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)))
                .addGap(18, 18, 18)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 31, Short.MAX_VALUE))
                .addGap(85, 85, 85))
        );

        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(yaver10.Yaver10App.class).getContext().getActionMap(Yaver10View.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 779, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 609, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel)
                    .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        try {
            // TODO add your handling code here:
            MapMode = ((String) jComboBox1.getSelectedItem()).toLowerCase();
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_jComboBox1ActionPerformed

    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
        // TODO add your handling code here:
        int value = jSlider1.getValue();
        //       System.out.println(value);
        zoomFactor=value;
        try {
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_jSlider1StateChanged

    private void button6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button6ActionPerformed
        // TODO add your handling code here:
        Double decrement = (1.0/(zoomFactor*zoomFactor))*0.256;
        System.out.println(decrement);
        longtitude-=decrement;
        try {
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_button6ActionPerformed

    private void button5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button5ActionPerformed
        // TODO add your handling code here:
        Double increment = (1.0/(zoomFactor*zoomFactor))*0.256;
        longtitude+=increment;
        try {
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_button5ActionPerformed

    private void button4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button4ActionPerformed
        // TODO add your handling code here:
        Double decrement = (1.0/(zoomFactor*zoomFactor))*0.256;
        latitude-=decrement;
        try {
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
        
}//GEN-LAST:event_button4ActionPerformed

    private void button3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button3ActionPerformed
        // TODO add your handling code here:
        Double increment = (1.0/(zoomFactor*zoomFactor))*0.256;
        latitude+=increment;
        try {
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_button3ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        String N=jTextField1.getText();
        latitude=Double.parseDouble(N);
//        System.out.println(lot);
        String S=jTextField2.getText();
        longtitude=Double.parseDouble(S);
        try {
            ReMap();
            //        System.out.println(lat);
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTextField1FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusGained
        // TODO add your handling code here:
        jTextField1.requestFocus();
    }//GEN-LAST:event_jTextField1FocusGained

    private void jTextField2FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField2FocusGained
        // TODO add your handling code here:
        jTextField2.requestFocus();
    }//GEN-LAST:event_jTextField2FocusGained

    private void jTextField1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextField1MouseClicked
        // TODO add your handling code here:
        jTextField1.requestFocus();
    }//GEN-LAST:event_jTextField1MouseClicked

    private void jTextField2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextField2MouseClicked
        // TODO add your handling code here:
        jTextField2.requestFocus();
    }//GEN-LAST:event_jTextField2MouseClicked

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        jLabel5.setVisible(false);
        jLabel6.setVisible(false);
        jLabel7.setVisible(false);
        try {
            // TODO add your handling code here:
            String[] args = null;
            others.Assignment.main(args);
            //      others.Assignment.main(args);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }


    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        String[] args=null;
        others.Messages.main(args);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        String[] args=null;
        others.Filtering.main(args);
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jTextPane1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextPane1MouseDragged
        // TODO add your handling code here:
        if(currentMouseX!=0 && currentMouseY!=0)
        {
        deltaMouseX=evt.getX()-currentMouseX;
        deltaMouseY=evt.getY()-currentMouseY;
        if(zoomFactor<13)
        {
        longtitude-=(deltaMouseX*0.0001)*(20/zoomFactor);
        latitude+=(deltaMouseY*0.0001)*(20/zoomFactor);
        }
        else if(zoomFactor<15)
        {
        longtitude-=(deltaMouseX*0.000016)*(20/zoomFactor);
        latitude+=(deltaMouseY*0.000016)*(20/zoomFactor);
        }
        else if(zoomFactor<15)
        {
        longtitude-=(deltaMouseX*0.000004)*(20/zoomFactor);
        latitude+=(deltaMouseY*0.000004)*(20/zoomFactor);
        }
        else if(zoomFactor<18)
        {
        longtitude-=(deltaMouseX*0.000002)*(20/zoomFactor);
        latitude+=(deltaMouseY*0.000002)*(20/zoomFactor);
        }
        else
        {
        longtitude-=(deltaMouseX*0.0000001)*(20/zoomFactor);
        latitude+=(deltaMouseY*0.0000001)*(20/zoomFactor);
        }
        
        }

    }//GEN-LAST:event_jTextPane1MouseDragged

    private void jTextPane1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextPane1MousePressed
        // TODO add your handling code here:
        Cursor curs = new Cursor(Cursor.MOVE_CURSOR);
        jTextPane1.setCursor(curs);

        currentMouseX = evt.getX();
        currentMouseY = evt.getY();
       
    }//GEN-LAST:event_jTextPane1MousePressed

    private void jTextPane1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextPane1MouseReleased
        // TODO add your handling code here:
       if(currentMouseX!=0 && currentMouseY!=0)
        {
        try {
                ReMap();
            } catch (IOException ex) {
                Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
            }
        currentMouseX=0;
        currentMouseY=0;
        }
       Cursor curs = new Cursor(Cursor.DEFAULT_CURSOR);
       jTextPane1.setCursor(curs);
    }//GEN-LAST:event_jTextPane1MouseReleased

    private void jTextPane1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextPane1MouseClicked

    }//GEN-LAST:event_jTextPane1MouseClicked

    private void mainPanelFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_mainPanelFocusGained

    }//GEN-LAST:event_mainPanelFocusGained

    private void mainPanelMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mainPanelMouseEntered
        // TODO add your handling code here:
        
    }//GEN-LAST:event_mainPanelMouseEntered

    private void mainPanelMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mainPanelMousePressed
        // TODO add your handling code here:
         try {
            // TODO add your handling code here:
            ReMap();
        } catch (IOException ex) {
            Logger.getLogger(Yaver10View.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_mainPanelMousePressed

    public static void ReDesignGUIUp()
    {
        int width=jButton3.getWidth();
        int height=jButton3.getHeight();
        jButton3.setSize(width+10,height+5);
        jButton4.setVisible(false);
    }

    public static void ReDesignGUIDown()
    {
        int width=jButton3.getWidth();
        int height=jButton3.getHeight();
        jButton3.setSize(width-5,height-2);
        jButton4.setVisible(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private static java.awt.Button button3;
    private static java.awt.Button button4;
    private static java.awt.Button button5;
    private static java.awt.Button button6;
    private static javax.swing.JButton jButton1;
    private static javax.swing.JButton jButton2;
    public static javax.swing.JButton jButton3;
    public static javax.swing.JButton jButton4;
    private static javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private static javax.swing.JLabel jLabel3;
    private static javax.swing.JLabel jLabel4;
    public static javax.swing.JLabel jLabel5;
    public static javax.swing.JLabel jLabel6;
    public static javax.swing.JLabel jLabel7;
    private javax.swing.JScrollPane jScrollPane1;
    private static javax.swing.JSlider jSlider1;
    private static javax.swing.JTextField jTextField1;
    private static javax.swing.JTextField jTextField2;
    public static javax.swing.JTextPane jTextPane1;
    private java.awt.Label label1;
    public static javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;
    private static int zoomFactor=16;
    public static double latitude=39.8914;
    public static double longtitude=32.7846;
    private static String MapMode="hybrid";
    private JDialog aboutBox;
    private int currentMouseX = 0;
    private int currentMouseY = 0;
    private int deltaMouseX = 0;
    private int deltaMouseY = 0;
    public static String markers = "";
}
